diff --git a/src/bin/pg_dump/parallel.c b/src/bin/pg_dump/parallel.c
new file mode 100644
index caedbb8..4efa8fb
*** a/src/bin/pg_dump/parallel.c
--- b/src/bin/pg_dump/parallel.c
*************** readMessageFromPipe(int fd)
*** 1320,1337 ****
  /*
   * This is a replacement version of pipe for Win32 which allows returned
   * handles to be used in select(). Note that read/write calls must be replaced
!  * with recv/send.
   */
  static int
  pgpipe(int handles[2])
  {
! 	SOCKET		s;
  	struct sockaddr_in serv_addr;
  	int			len = sizeof(serv_addr);
  
  	handles[0] = handles[1] = INVALID_SOCKET;
  
! 	if ((s = socket(AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET)
  	{
  		write_msg(modulename, "pgpipe: could not create socket: error code %d\n",
  				  WSAGetLastError());
--- 1320,1342 ----
  /*
   * This is a replacement version of pipe for Win32 which allows returned
   * handles to be used in select(). Note that read/write calls must be replaced
!  * with recv/send.  "handles" have to be integers so we check for errors then
!  * cast to integers.
   */
  static int
  pgpipe(int handles[2])
  {
! 	pgsocket		s, tmp_sock;
  	struct sockaddr_in serv_addr;
  	int			len = sizeof(serv_addr);
  
+ 	/* We have to use the Unix socket definition here. */
  	handles[0] = handles[1] = INVALID_SOCKET;
  
! 	/*
! 	 * setup listen socket
! 	 */
! 	if ((s = socket(AF_INET, SOCK_STREAM, 0)) == PGINVALID_SOCKET)
  	{
  		write_msg(modulename, "pgpipe: could not create socket: error code %d\n",
  				  WSAGetLastError());
*************** pgpipe(int handles[2])
*** 1363,1375 ****
  		closesocket(s);
  		return -1;
  	}
! 	if ((handles[1] = socket(AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET)
  	{
  		write_msg(modulename, "pgpipe: could not create second socket: error code %d\n",
  				  WSAGetLastError());
  		closesocket(s);
  		return -1;
  	}
  
  	if (connect(handles[1], (SOCKADDR *) &serv_addr, len) == SOCKET_ERROR)
  	{
--- 1368,1385 ----
  		closesocket(s);
  		return -1;
  	}
! 
! 	/*
! 	 * setup pipe handles
! 	 */
! 	if ((tmp_sock = socket(AF_INET, SOCK_STREAM, 0)) == PGINVALID_SOCKET)
  	{
  		write_msg(modulename, "pgpipe: could not create second socket: error code %d\n",
  				  WSAGetLastError());
  		closesocket(s);
  		return -1;
  	}
+ 	handles[1] = (int) tmp_sock;
  
  	if (connect(handles[1], (SOCKADDR *) &serv_addr, len) == SOCKET_ERROR)
  	{
*************** pgpipe(int handles[2])
*** 1378,1384 ****
  		closesocket(s);
  		return -1;
  	}
! 	if ((handles[0] = accept(s, (SOCKADDR *) &serv_addr, &len)) == INVALID_SOCKET)
  	{
  		write_msg(modulename, "pgpipe: could not accept connection: error code %d\n",
  				  WSAGetLastError());
--- 1388,1394 ----
  		closesocket(s);
  		return -1;
  	}
! 	if ((tmp_sock = accept(s, (SOCKADDR *) &serv_addr, &len)) == PGINVALID_SOCKET)
  	{
  		write_msg(modulename, "pgpipe: could not accept connection: error code %d\n",
  				  WSAGetLastError());
*************** pgpipe(int handles[2])
*** 1387,1392 ****
--- 1397,1404 ----
  		closesocket(s);
  		return -1;
  	}
+ 	handles[0] = (int) tmp_sock;
+ 
  	closesocket(s);
  	return 0;
  }
